
QGIS Application - Bug report #8656

WMS GetFeatureInfo Filter: No results

2013-09-24 07:13 AM - Carl Defevere

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: QGIS Server

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17386

Description

My WMS GetFeatureInfo Filter (QGis Server 2.0.1) returns no results while there should be.

(The Identify GetFeatureInfo and the GetMap Filter works fine.)

URL:

http://localhost/wms/consultatie?&_dc=1379946073184&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetFeatureInfo&LAYERS=La

RS=Layername&QUERY_LAYERS=Layername&FEATURE_COUNT=10&INFO_FORMAT=text%2Fxml&SRS=EPSG%3A31370&FILTER=Layername%3A%22ID%22%20%3D%20%271%27


0&FILTER=Layername%3A%22ID%22%20%3D%20%271%27

Response:

<GetFeatureInfoResponse>

 <BoundingBox CRS="EPSG:31370" maxx="0" minx="0" maxy="0" miny="0"/>

 <Layer name="Layername"/>

</GetFeatureInfoResponse>

Related issues:

Related to QGIS Application - Bug report # 8871: WFS doesn't use bounding box! Closed 2013-10-16

Associated revisions

Revision b956874f - 2016-05-19 10:20 PM - Alessandro Pasotti 

[server][bugfix] FILTER GetFeatureInfo working again

Fixes #8656

Revision 2aceb896 - 2016-08-23 05:02 PM - Alessandro Pasotti 

[server][bugfix] FILTER GetFeatureInfo working again

Fixes #8656

History

#1 - 2013-09-28 03:20 AM - Jukka Rahkonen

Where does the query come from? It is not a valid GetFeatureInfo query because it is missing BBOX, X and Y parameters.

Jukka Rahkonen
#2 - 2013-09-28 05:01 AM - Giovanni Manghi

- Status changed from Open to Feedback

#3 - 2013-09-29 10:50 PM - Carl Defevere

The query is generated by pressing the 'Search'-button in the QGIS Web Client.

It used to work in the 1.8 version.

And the query seems correct according to https://github.com/qgis/qgis-web-client : 

Request URL:

When performing a search query using the above configuration,

the following get request will be made.

``http://localhost/wms/helloworld?SERVICE=WMS&VERSION=1.1.1&

REQUEST=GetFeatureInfo&LAYERS=Country&QUERY_LAYERS=Country&

FEATURE_COUNT=10&INFO_FORMAT=text/xml&SRS=EPSG:4326&

FILTER=Country:"name"+=+'africa'``

#4 - 2013-09-30 12:37 AM - Giovanni Manghi

Carl Defevere wrote:

The query is generated by pressing the 'Search'-button in the QGIS Web Client.

It used to work in the 1.8 version.

And the query seems correct according to https://github.com/qgis/qgis-web-client : 

[...]

So maybe something changed in qgis server and qgis web client wasn't updated accordingly?

#5 - 2013-09-30 01:57 AM - Carl Defevere

I don't think it's a QGis Web Client problem. Browsing the wms-url without using the web client doesn't return results either.

Maybe it's similar with #7258

#6 - 2013-10-11 06:40 AM - Carl Defevere

WMS GetFeatureInfo, using Identify-tool

Request URL: 
http://localhost/wms/publiek/raadpleging?SERVICE=WMS&VERSION=1.1.1&REQUEST=GetFeatureInfo&BBOX=53917.490672%2C202904.71

0821%2C73594.356343%2C208748.460821&FEATURE_COUNT=10&HEIGHT=335&WIDTH=1128&FORMAT=image%2Fjpeg&INFO_FORMAT=text%2Fxml&SRS=EPSG%3A31370&X=345&Y=297&QUERY_LAYERS=Deelgemeenten


AT=text%2Fxml&SRS=EPSG%3A31370&X=345&Y=297&QUERY_LAYERS=Deelgemeenten

Response (Works fine):

<GetFeatureInfoResponse>

 <Layer name="Deelgemeenten">

  <Feature id="0">

   <Attribute value="31001" name="CADIKEY"/>

   <Attribute value="21801.1026993" name="Shape_Leng"/>

   <Attribute value="21696901.0521" name="Shape_Area"/>

   <Attribute value="31040" name="ADMUKEY"/>

   <Attribute value="ZEDELGEM  4 AFD/AARTRIJKE/" name="CADINA"/>

   <Attribute value="POLYGON((60530.17100000000209548...))" type="derived" name="geometry"/>

  </Feature>

 </Layer>

 <Layer name="Adresposities"/>

</GetFeatureInfoResponse>

WFS GetFeature

Request URL: 

http://localhost/wms/publiek/raadpleging?SERVICE=WFS&VERSION=1.0.0&REQUEST=GetFeature&TYPENAME=Deelgemeenten&SRSNAME

=EPSG:31370&FILTER=%3CFilter%3E%3CPropertyIsEqualTo%3E%3CPropertyName%3ECADIKEY%3C/PropertyName%3E%3CLiteral%3E31040%3C/Literal%3E%3C/PropertyIsEqualTo%3E%3C/Filter%3E


1040%3C/Literal%3E%3C/PropertyIsEqualTo%3E%3C/Filter%3E

Response (Works fine):

<wfs:FeatureCollection xmlns:wfs="http://www.opengis.net/wfs" xmlns:ogc="http://www.opengis.net/ogc" xmlns:gml="http://www.opengis.net/gml"

xmlns:ows="http://www.opengis.net/ows" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:qgs="http://www.qgis.org/gml"

xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.opengis.net/wfs

http://schemas.opengis.net/wfs/1.0.0/wfs.xsd http://www.qgis.org/gml

http://localhost/wms/publiek/raadpleging?SRSNAME=EPSG:31370&amp;SERVICE=WFS&amp;VERSION=1.0.0&amp;REQUEST=DescribeFeatureType&amp;TYPENAME=Deelgemeenten&amp;OUTPUTFORMAT=XMLSCHEMA"><gml:boundedBy>
 <gml:Box srsName="EPSG:31370">
 ...
 ...
  <qgs:CADIKEY>31040</qgs:CADIKEY>
  <qgs:Shape_Leng>18611.272083</qgs:Shape_Leng>
  <qgs:Shape_Area>15332522.7121</qgs:Shape_Area>
  <qgs:ADMUKEY>31040</qgs:ADMUKEY>
  <qgs:CADINA>ZEDELGEM  1 AFD/ZEDELGEM/</qgs:CADINA>
 </qgs:Deelgemeenten>
</gml:featureMember>
</wfs:FeatureCollection>


tureType&amp;TYPENAME=Deelgemeenten&amp;OUTPUTFORMAT=XMLSCHEMA"><gml:boundedBy>

 <gml:Box srsName="EPSG:31370">

 ...

 ...

  <qgs:CADIKEY>31040</qgs:CADIKEY>

  <qgs:Shape_Leng>18611.272083</qgs:Shape_Leng>

  <qgs:Shape_Area>15332522.7121</qgs:Shape_Area>

  <qgs:ADMUKEY>31040</qgs:ADMUKEY>

  <qgs:CADINA>ZEDELGEM  1 AFD/ZEDELGEM/</qgs:CADINA>

 </qgs:Deelgemeenten>

</gml:featureMember>

</wfs:FeatureCollection>
WMS GetFeatureInfo, using FILTER

Request URL: 

http://localhost/wms/publiek/raadpleging?&_dc=1379946073184&SERVICE=WMS&VERSION=1.1.1&REQUEST=GetFeatureInfo&LAYERS=De

elgemeenten&QUERY_LAYERS=Deelgemeenten&FEATURE_COUNT=10&INFO_FORMAT=text%2Fxml&SRS=EPSG%3A31370&FILTER=Deelgemeenten:"CADIKEY" = '31040'



elgemeenten:"CADIKEY" = '31040'

Response (Doesn't work):

<GetFeatureInfoResponse>

<BoundingBox CRS="EPSG:31370" maxx="0" minx="0" maxy="0" miny="0"/>

<Layer name="Deelgemeenten"/>

</GetFeatureInfoResponse>

#7 - 2014-04-28 06:40 AM - mlennert -

I can confirm Carl's experience:

Using Debian package qgis-mapserver 2.2.0-1, I get a response for a getfeatureinfo request on a wms layer when using specific coordinates (x,y), but I

get no result when I launch a getfeatureinfo request with the filter parameter.

Moritz

#8 - 2014-06-23 07:05 AM - Giovanni Manghi

- Affected QGIS version changed from 2.0.1 to master

- Status changed from Feedback to Open

- Target version set to Version 2.4

#9 - 2014-06-28 07:45 AM - Jürgen Fischer

- Target version changed from Version 2.4 to Future Release - High Priority

#10 - 2014-08-13 07:47 AM - Roberto Marzocchi

perhaps correlated with bug report #7258?

mlennert - wrote:

I can confirm Carl's experience:

Using Debian package qgis-mapserver 2.2.0-1, I get a response for a getfeatureinfo request on a wms layer when using specific coordinates (x,y),

but I get no result when I launch a getfeatureinfo request with the filter parameter.

Moritz
#11 - 2016-05-19 10:29 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#12 - 2016-05-19 01:22 PM - Anonymous

- Status changed from Open to Closed

Fixed in changeset commit:"b956874f02a9379b0a9503d6c25fe014dc41bd5a".
